Index: trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/TaskInstanceTrieTest.java
===================================================================
--- trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/TaskInstanceTrieTest.java	(revision 1281)
+++ trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/TaskInstanceTrieTest.java	(revision 1285)
@@ -37,7 +37,8 @@
 
 /**
- * The class <code>TaskInstanceTrieTest</code> contains tests for the class <code>{@link TaskInstanceTrie}</code>.
+ * The class <code>TaskInstanceTrieTest</code> contains tests for the class
+ * <code>{@link TaskInstanceTrie}</code>.
  * 
- * @author Steffen Herbold
+ * @author Patrick Harms
  * @version 1.0
  */
@@ -54,5 +55,6 @@
     
     /** */
-    private TaskComparator comparator = new TaskComparator(TaskEquality.SEMANTICALLY_EQUAL);
+    private TaskHandlingStrategy strategy =
+        new TaskHandlingStrategy(TaskEquality.IDENTICAL);
     
     /** */
@@ -84,5 +86,5 @@
     @Test
     public void testTaskInstanceTaskInstanceTrie_1() throws Exception {
-        TaskInstanceTrie result = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie result = new TaskInstanceTrie(strategy);
 
         assertNotNull(result);
@@ -95,10 +97,10 @@
     @Test(expected = java.lang.IllegalArgumentException.class)
     public void testTaskInstanceTrie_2() throws Exception {
-        new TaskInstanceTrie((TaskComparator) null);
+        new TaskInstanceTrie((TaskHandlingStrategy) null);
     }
 
     @Test
     public void testTrainSessions_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -136,5 +138,5 @@
     @Test
     public void testTrainSessions_2() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -167,5 +169,5 @@
     @Test
     public void testTrainSessions_3() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -199,5 +201,5 @@
     @Test
     public void testTrainSessions_4() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -240,5 +242,5 @@
     @Test
     public void testTrainSessions_5() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -276,5 +278,5 @@
     @Test
     public void testTrainSessions_6() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -313,5 +315,5 @@
     @Test
     public void testTrainSessions_7() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -354,5 +356,5 @@
     @Test
     public void testTrainSessions_8() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -390,5 +392,5 @@
     @Test
     public void testTrainSessions_9() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         IUserSession session = (IUserSession) decoder.decode
@@ -428,5 +430,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -445,5 +447,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_2() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
         
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -510,5 +512,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_3() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -554,5 +556,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_4() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -566,5 +568,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_5() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -583,5 +585,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_6() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -596,5 +598,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_7() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -629,5 +631,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_8() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -688,5 +690,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_9() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -726,5 +728,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_10() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -738,5 +740,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_11() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -762,5 +764,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_12() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -809,5 +811,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_13() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -822,5 +824,5 @@
     @Test
     public void testGetSequencesWithMostOccurrences_14() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                     
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -835,5 +837,5 @@
     @Test
     public void testGetCount_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                         
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -850,5 +852,5 @@
     @Test
     public void testGetCount_2() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -865,5 +867,5 @@
     @Test
     public void testGetCount_3() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -879,5 +881,5 @@
     @Test
     public void testGetCount_4() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -893,5 +895,5 @@
     @Test
     public void testGetCount_5() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -908,5 +910,5 @@
     @Test
     public void testGetCount_6() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                 
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -922,5 +924,5 @@
     @Test
     public void testGetFollowingSymbols_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                     
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -940,5 +942,5 @@
     @Test
     public void testGetFollowingSymbols_2() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                         
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -956,5 +958,5 @@
     @Test
     public void testGetFollowingSymbols_3() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                         
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -970,5 +972,5 @@
     @Test
     public void testGetNumLeafAncestors_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -981,5 +983,5 @@
     @Test
     public void testGetNumLeafs_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -992,5 +994,5 @@
     @Test
     public void testGetNumSymbols_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
                                             
         fixture.trainSessions(Arrays.asList(session), 3);
@@ -1004,5 +1006,5 @@
     @Test
     public void testLargeTaskInstanceTrie_1() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 2;
@@ -1024,5 +1026,5 @@
     @Test
     public void testLargeTaskInstanceTrie_2() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 2;
@@ -1044,5 +1046,5 @@
     @Test
     public void testLargeTaskInstanceTrie_3() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 2;
@@ -1064,5 +1066,5 @@
     @Test
     public void testLargeTaskInstanceTrie_4() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 2;
@@ -1084,5 +1086,5 @@
     @Test
     public void testLargeTaskInstanceTrie_5() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 2;
@@ -1104,5 +1106,5 @@
     @Test
     public void testLargeTaskInstanceTrie_6() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 3;
@@ -1124,5 +1126,5 @@
     @Test
     public void testLargeTaskInstanceTrie_7() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 3;
@@ -1144,5 +1146,5 @@
     @Test
     public void testLargeTaskInstanceTrie_8() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 3;
@@ -1164,5 +1166,5 @@
     @Test
     public void testLargeTaskInstanceTrie_9() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 3;
@@ -1184,5 +1186,5 @@
     @Test
     public void testLargeTaskInstanceTrie_10() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 3;
@@ -1204,5 +1206,5 @@
     @Test
     public void testLargeTaskInstanceTrie_11() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 4;
@@ -1224,5 +1226,5 @@
     @Test
     public void testLargeTaskInstanceTrie_12() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 4;
@@ -1244,5 +1246,5 @@
     @Test
     public void testLargeTaskInstanceTrie_13() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 4;
@@ -1264,5 +1266,5 @@
     @Test
     public void testLargeTaskInstanceTrie_14() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 4;
@@ -1284,5 +1286,5 @@
     @Test
     public void testLargeTaskInstanceTrie_15() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 4;
@@ -1304,5 +1306,5 @@
     @Test
     public void testLargeTaskInstanceTrie_16() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 5;
@@ -1324,5 +1326,5 @@
     @Test
     public void testLargeTaskInstanceTrie_17() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 5;
@@ -1344,5 +1346,5 @@
     @Test
     public void testLargeTaskInstanceTrie_18() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 5;
@@ -1364,5 +1366,5 @@
     @Test
     public void testLargeTaskInstanceTrie_19() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 5;
@@ -1384,5 +1386,5 @@
     @Test
     public void testLargeTaskInstanceTrie_20() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 5;
@@ -1404,5 +1406,5 @@
     @Test
     public void testLargeTaskInstanceTrie_21() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 6;
@@ -1424,5 +1426,5 @@
     @Test
     public void testLargeTaskInstanceTrie_22() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 6;
@@ -1444,5 +1446,5 @@
     @Test
     public void testLargeTaskInstanceTrie_23() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 6;
@@ -1464,5 +1466,5 @@
     @Test
     public void testLargeTaskInstanceTrie_24() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 6;
@@ -1484,5 +1486,5 @@
     @Test
     public void testLargeTaskInstanceTrie_25() throws Exception {
-        TaskInstanceTrie fixture = new TaskInstanceTrie(comparator);
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
 
         int order = 6;
@@ -1493,4 +1495,24 @@
         fixture.trainSessions(Arrays.asList(tester.userSession), order);
         System.out.println("testing session with 10000 task instances and 1000 symbols took " +
+                           (System.currentTimeMillis() - start) + "ms");
+        
+        fixture.process(tester);
+        
+        // do not check if counts is empty, as some sequences may not be part of the reduced trie
+        // and may therefore not be processed by the tester.
+        //assertTrue(tester.counts.isEmpty());
+    }
+
+    @Test
+    public void testLargeTaskInstanceTrie_26() throws Exception {
+        TaskInstanceTrie fixture = new TaskInstanceTrie(strategy);
+
+        int order = 3;
+        
+        TaskInstanceTrieTester tester = new TaskInstanceTrieTester(1000, 1000000, order);
+
+        long start = System.currentTimeMillis();
+        fixture.trainSessions(Arrays.asList(tester.userSession), order);
+        System.out.println("testing session with 1000000 task instances and 1000 symbols took " +
                            (System.currentTimeMillis() - start) + "ms");
         
@@ -1513,5 +1535,5 @@
                 found = true;
                 for (int i = 0; i < containedList.size(); i++) {
-                    if (!comparator.equals(candidate.get(0), containedList.get(0))) {
+                    if (!strategy.getTaskComparator().equals(candidate.get(0), containedList.get(0))) {
                         found = false;
                         break;
@@ -1660,5 +1682,5 @@
                 
                 for (Map.Entry<Integer, ITaskInstance> entry : symbols.entrySet()) {
-                    if (comparator.equals(entry.getValue(), symbol)) {
+                    if (strategy.getTaskComparator().equals(entry.getValue(), symbol)) {
                         symbolIndex = entry.getKey();
                         break;
